package com.example.bluetoothprintimage;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.util.Set;

import android.app.Dialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.content.Intent;
import android.widget.Toast;

public class BluetoothUtils extends Thread{
	
	BluetoothDevice mmDevice = null;
	BluetoothSocket mmSocket;
	Context context;
	Dialog dialog;
	
	public BluetoothUtils(Context context, BluetoothDevice mmDevice){
		this.context = context;
		this.mmDevice = mmDevice;
		this.dialog = new Dialog(context);
		this.dialog.setTitle("Connecting....");
		this.dialog.setCancelable(false);
		this.dialog.show();
	
	}
	/**
	 * 
	 * @return
	 */
	public static boolean isDeviceSupportedBluetooth()throws Exception{
		
		return BluetoothAdapter.getDefaultAdapter() == null ? false : true;
	
	}
	
	/**
	 * 
	 * @return
	 */
	public static boolean isBluetoothEnable(Context context)throws Exception{
		if(isDeviceSupportedBluetooth()){
		
			return BluetoothAdapter.getDefaultAdapter().isEnabled();
	
		}else{
		
			Toast.makeText(context, "Device not supported bluetooth",Toast.LENGTH_SHORT).show();
			return false;
		}
	}
	/**
	 * 
	 * @return
	 * @throws Exception
	 */
	public static Set<BluetoothDevice> getPairedDevices()throws Exception{
		
		return BluetoothAdapter.getDefaultAdapter().getBondedDevices();

	}
	
	/**
	 * 
	 */
	public static  void enableBlueTooth(Context context){
		Intent enableBluetooth = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
		((MainActivity)context).startActivityForResult(enableBluetooth, 0);
	}
	
	public static void printImage(byte[] data, Context context){
		OutputStream mmOutputStream = ((MainActivity)context).outputStream;
		try {

			
			
	         mmOutputStream.write(data);
	         mmOutputStream.flush();
	         
		} catch (NullPointerException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}finally{
			
		}
	}

	

	
	
	boolean connected = false;
	
	@Override
	public void run() {
		// TODO Auto-generated method stub
		
		
		try {
			
			Method m = mmDevice.getClass().getMethod("createRfcommSocket", new Class[] {int.class});
			mmSocket = (BluetoothSocket) m.invoke(mmDevice, 1);
			
			mmSocket.connect();
			
			((MainActivity)context).outputStream = mmSocket.getOutputStream();
			
			connected = true;
			
		} catch (Exception e) {
			e.printStackTrace();
			
			connected = false;
			
		}finally{
			((MainActivity)context).runOnUiThread(new Runnable() {
				
				@Override
				public void run() {
					((MainActivity)context).statusTextView.setText(connected ? "Connected" : "Not connected" );
					dialog.dismiss();
				}
			});
		}
	}
	
	
}
