package com.example.bluetoothprintimage;

import java.util.Set;

import android.app.Dialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class PairedDevicesDialog extends Dialog implements OnItemClickListener{

	BluetoothAdapter mBluetoothAdapter;
	Set<BluetoothDevice> boundedDevices;
	Object boundedDeviceArray[];
	Context context;
	ListView boundedDeviceListView;
	String data[] = null;
	public PairedDevicesDialog(Context context) throws Exception {
		super(context);
		this.setTitle("Select Bluetooth printer.");
		this.context = context;
		this.mBluetoothAdapter= BluetoothAdapter.getDefaultAdapter();	
		
		this.boundedDevices = BluetoothUtils.getPairedDevices();
		this.boundedDeviceArray = this.boundedDevices.toArray();
		
		this.boundedDeviceListView = new ListView(context);
		//ArrayAdapter<Object> adapter = new ArrayAdapter<Object>(context, android.R.layout.simple_list_item_1, boundedDeviceArray);
		
		this.boundedDeviceListView.setAdapter(new CustomArrayAdapter(context, android.R.layout.simple_list_item_1, boundedDeviceArray));
		this.boundedDeviceListView.setOnItemClickListener(this);
		
		this.setContentView(this.boundedDeviceListView);
		
		
	}
	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position,
			long id) {
		
		BluetoothDevice bluetoothDevice = (BluetoothDevice) view.getTag();
		
		new BluetoothUtils(context, bluetoothDevice).start();
		
		this.dismiss();
		
		
	}
	
	/**
	 * 
	 * @author lauro
	 *
	 */
	class CustomArrayAdapter extends ArrayAdapter<Object>{

		Object boundedDeviceArray[];
		public CustomArrayAdapter(Context context, int resource,Object boundedDeviceArray[]) {
			super(context, resource, boundedDeviceArray);
			
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			
			BluetoothDevice bluetoothDevice = (BluetoothDevice) this.getItem(position);
			String bluetoothName = bluetoothDevice.getName();
			
			if(convertView == null){
				convertView = ((MainActivity) context).getLayoutInflater().inflate(android.R.layout.simple_list_item_1, null);
			}
			
			TextView textView = (TextView) convertView;
			textView.setText(bluetoothName);
			textView.setTag(bluetoothDevice);
			return convertView;
		}
		
	}
	
}
