package com.example.bluetoothprintimage;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;



public class PrintTool {

	
	/**
	 * print photo with path Print pictures according to the picture path
	 * 
	 * @param 
	 * */
	public static void printPhotoWithPath(String filePath, Context context) {

		// Get the picture based on the path
		File mfile = new File(filePath/*path*/);
		if (mfile.exists()) {
			Bitmap bmp = BitmapFactory.decodeFile(filePath/*path*/);
			byte[] command = decodeBitmap(bmp);
			printPhoto(command, context);
			
			
		}else{
			Log.e("PrintTools_58mm", "the file isn't exists");
		}
	}

	
	
	/**
	 * decode bitmap to bytes decoded byte stream Bitmap bitmap
	 * */
	public static byte[] decodeBitmap(Bitmap bmp){
		int bmpWidth = bmp.getWidth();
		int bmpHeight = bmp.getHeight();

		List<String> list = new ArrayList<String>(); //binaryString list
		StringBuffer sb;

		// Per line ( divided by 8 , make up less than 0 ) byte
		int bitLen = bmpWidth / 8;
		int zeroCount = bmpWidth % 8;
		// Each line should be added 0
		String zeroStr = "";
		if (zeroCount > 0) {
			bitLen = bmpWidth / 8 + 1;
			for (int i = 0; i < (8 - zeroCount); i++) {
				zeroStr = zeroStr + "0";
			}
		}
		// Read pixel color individually , the non-white to black
		for (int i = 0; i < bmpHeight; i++) {
			sb = new StringBuffer();
			for (int j = 0; j < bmpWidth; j++) {
				int color = bmp.getPixel(j, i); // Bitmap images to get a point for each color color values
				//R G B color values
				int r = (color >> 16) & 0xff;
				int g = (color >> 8) & 0xff;
				int b = color & 0xff;

				// if color close to white，bit='0', else bit='1'
				if (r > 160 && g > 160 && b > 160)
					sb.append("0");
				else
					sb.append("1");
			}
			// At the end of each line , add the remaining 0
			if (zeroCount > 0) {
				sb.append(zeroStr);
			}
			list.add(sb.toString());
		}
		// binaryStr called once every eight conversion method , and then flatten
		List<String> bmpHexList = ConvertUtil.binaryListToHexStringList(list);
		String commandHexString = "1D763000";
		// Width instruction
		String widthHexString = Integer.toHexString(bmpWidth % 8 == 0 ? bmpWidth / 8 : (bmpWidth / 8 + 1));
		if (widthHexString.length() > 2) {
			Log.e("decodeBitmap error", "Width beyond the width is too large");
			return null;
		} else if (widthHexString.length() == 1) {
			widthHexString = "0" + widthHexString;
		}
		widthHexString = widthHexString + "00";

		// Highly directive
		String heightHexString = Integer.toHexString(bmpHeight);
		if (heightHexString.length() > 2) {
			Log.e("decodeBitmap error", "Height exceeds height is too large");
			return null;
		} else if (heightHexString.length() == 1) {
			heightHexString = "0" + heightHexString;
		}
		heightHexString = heightHexString + "00";
		
		List<String> commandList = new ArrayList<String>();
		commandList.add(commandHexString+widthHexString+heightHexString);
		commandList.addAll(bmpHexList);
		
		return ConvertUtil.hexList2Byte(commandList);
	}
	
	
	/**
	 * print photo with bytes. According to the instructions printed pictures
	 * */
	public static void printPhoto(byte[] bytes, Context context) {
		
		BluetoothUtils.printImage(bytes, context);
	
	}

	

	





}